#!/usr/bin/env python

from __future__ import print_function

import os
import sys
import base64
import socket
import uuid

import base32hex

#import gnupg

#gnupghome = os.path.abspath(os.path.dirname(__file__)+'.gnupg')
#gpg = gnupg.GPG(gnupghome=gnupghome)
#gpg.encoding = 'utf-8'

#secret_keys = gpg.list_keys(True)
#public_keys = gpg.list_keys()

domain = 'dyn.cpuhouse.cloud'

salt = str(uuid.uuid4())[:8]
host = '%s.%s' % (salt, domain)


def validate_uuid4(uuid_string):

    try:
        val = uuid.UUID(uuid_string, version=4)
    except ValueError:
        # If it's a value error, then the string 
        # is not a valid hex code for a UUID.
        return False

    return True


def generate_ddns_challenge():
    ddns_uuid  = uuid.uuid5(uuid.NAMESPACE_DNS, host).urn
    ddns_txt_r = base64.b64encode('%s %s' %(salt, ddns_uuid))
    #print ('%s: %s' % (host, ddns_uuid))
    return ddns_txt_r


def validate_ddns_challenge(challenge):
    r_salt, r_ddns_uuid = (base64.b64decode(challenge)).split()
    print ('%s.%s: %s' % (r_salt,domain,r_ddns_uuid))


def generate_license(machine_id=None):
    if machine_id == None:
        machine_id = open('/etc/machine-id','r').read().lstrip().rstrip()

    """ generate license """
    if validate_uuid4(machine_id):
        salt = base32hex.b32encode(str(uuid.getnode()))[:4]
        license = base32hex.b32encode(uuid.UUID(machine_id, version=4).hex).rstrip(b'=')+salt
        license_array = map(''.join, zip(*[iter(license)]*8))
        license_str = '-'.join( e for e in license_array)
        return license_str


def validate_license(license):
    """ validate license """
    license_r = license.replace('-','')[:-4]+b'===='
    machine_id = (''.join(chr(o) for o in base32hex.b32decode(license_r)))

    print (machine_id)


ddns_challenge = generate_ddns_challenge()
print ('DNS site verification record:\n%s 300 IN TXT "cpuhouse-site-verification=%s"' % (host, ddns_challenge))
#validate_ddns_challenge(ddns_challenge)


license = generate_license()
print ('User license: %s' % license)
#validate_license('C4SJIDR6-6KRMAP9N-6KQ38C35-CPGJCOJ1-70PJ2E9H-6DGJGDPG-C4SG68R3')

# vim:number:sw=4:sts=4:ts=4:et:autoindent:syntax=python
